"""
$RCSfile: IXMLTransform.py,v $

XMLTransform automatically transforms an XML document via XSLT, where
the XML document is obtained from another Zope object via acquisition.
IXMLTransform is the interface implemented by XMLTransform.

Author: <a href="mailto:cstrong@arielpartners.com">Craeg Strong</a>
Release: 1.0
"""

__cvstag__  = '$Name:  $'[6:-2]
__date__    = '$Date: 2002/08/27 22:57:56 $'[6:-2]
__version__ = '$Revision: 1.6 $'[10:-2]

# Zope Base Classes
from Interface import Base

################################################################
# IXMLTransform interface
################################################################

class IXMLTransform(Base):
    """

    Automatically transforms an XML document via XSLT, where the XML
    document is obtained from another Zope object via acquisition.

    """

    def isCacheFileUpToDate(self, REQUEST=None):
        """

        Return 1 if and only if self should use the cached value
        rather than regenerating the transformed value, and the cache
        manager exists, and the cache file exists.  Note: this
        algorithm is rather simple and limited right now, but we
        intend to improve it over time.  Many items are not taken into
        account today: a) XML fragments that are included into the
        main document via the XSLT document() function b) XSLT
        transformer parameters c) XSLT transformers themselves (as
        well as all included and imported transformers).  FIXME cks
        11/26/2001

        """

    def findRegistry(self):
        """

        Find an instance of TransformerRegistry to obtain transformer
        information.
        
        """

    def findCacheManager(self):
        """

        Find an instance of CacheManager to use (optionally, provided
        the caching property is set to 'on')

        """

    def findSourceObject(self):
        """

        Retrieves the source Zope object (for XML content) via
        acquisition.

        """

    def getContents(self, REQUEST):
        """

        Retrieves the XML document to be transformed as a string from
        the source Zope object.

        """

    def transform(self, REQUEST):
        """

        Generate results using transformer and return them as a string

        """

    def transformAndCache(self, REQUEST):
        """

        Generate results using transformer and save them to the
        cache, if applicable

        """

    def setCachingOn(self, REQUEST=None):
        """

        same as changing the property.  For use in scripts or by the
        cache Manager

        """

    def setCachingOff(self, REQUEST=None):
        """

        same as changing the property.  For use in scripts or by the
        cache Manager

        """

    def isCachingOn(self):
        "Return TRUE if caching is turned on"

    def isDebugging(self):
        "Return true if and only if debugging is on."

